Index: trunk/LMDZ.GENERIC/libf/phystd/aeropacity.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/aeropacity.F90	(revision 803)
+++ trunk/LMDZ.GENERIC/libf/phystd/aeropacity.F90	(revision 804)
@@ -137,6 +137,6 @@
             aerosol(1:ngrid,1:nlayermx,iaer)=0.0
 !       2. Opacity calculation
-            if (noaero) then ! aerosol set to a very low value
-             aerosol(1:ngrid,1:nlayermx,iaer)=1.e-9
+            if (noaero) then ! aerosol set to zero
+             aerosol(1:ngrid,1:nlayermx,iaer)=0.0
             elseif (aerofixco2.or.(i_co2ice.eq.0)) then !  CO2 ice cloud prescribed
                aerosol(1:ngrid,1:nlayermx,iaer)=1.e-9
Index: trunk/LMDZ.GENERIC/libf/phystd/gfluxi.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/gfluxi.F	(revision 803)
+++ trunk/LMDZ.GENERIC/libf/phystd/gfluxi.F	(revision 804)
@@ -67,4 +67,17 @@
 
       DO L=1,L_NLAYRAD-1
+
+!----------------------------------------------------
+! There is a problem when W0 = 1
+!         open(888,file='W0')
+!           if ((W0(L).eq.0.).or.(W0(L).eq.1.)) then
+!             write(888,*) W0(L), L, 'gfluxi'
+!           endif
+! Prevent this with an if statement:
+        if (W0(L).eq.1.) then
+           W0(L) = 0.99999
+        endif
+!----------------------------------------------------
+
         ALPHA(L) = SQRT( (1.0-W0(L))/(1.0-W0(L)*COSBAR(L)) )
         LAMDA(L) = ALPHA(L)*(1.0-W0(L)*COSBAR(L))/UBARI
@@ -82,4 +95,9 @@
 
       L        = L_NLAYRAD
+
+      if (W0(L).eq.1.) then
+          W0(L) = 0.99999
+      end if
+
       ALPHA(L) = SQRT( (1.0-W0(L))/(1.0-W0(L)*COSBAR(L)) )
       LAMDA(L) = ALPHA(L)*(1.0-W0(L)*COSBAR(L))/UBARI
Index: trunk/LMDZ.GENERIC/libf/phystd/inifis.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/inifis.F	(revision 803)
+++ trunk/LMDZ.GENERIC/libf/phystd/inifis.F	(revision 804)
@@ -449,19 +449,4 @@
          call getin("satval",satval)
          write(*,*)" satval = ",satval
-
-! Test of incompatibility:
-! if no tracers, then the variable aerosols should be turned off
-         if ((.not.tracer).and.(.not.aerofixco2)) then
-           print*,'if tracers are off, you must turn aerofixco2 on.'
-           print*, '(i.e., you must fix the aerosol distribution)'
-           print*, 'This option was formerly known as aerofixed'
-           stop
-         endif
-         if ((.not.tracer).and.(.not.aerofixh2o)) then
-           print*,'if tracers are off, you must turn aerofixh2o on.'
-           print*, '(i.e., you must fix the aerosol distribution)'
-           print*, 'This option was formerly known as aerofixed'
-           stop
-         endif
 
 
Index: trunk/LMDZ.GENERIC/libf/phystd/physiq.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 803)
+++ trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 804)
@@ -451,6 +451,4 @@
       if (firstcall) then
 
-         print*,'FIRSTCALL INITIALIZATION'
-
          !! this is defined in comsaison_h
          ALLOCATE(mu0(ngrid))
@@ -598,6 +596,4 @@
                             ! need epsi for the wvp definitions in callcorrk.F
 
-         print*,'end FIRSTCALL INITIALIZATION'
-
       endif        !  (end of "if firstcall")
 
@@ -605,6 +601,4 @@
 ! 1.2   Initializations done at every physical timestep:
 ! ---------------------------------------------------
-
-      print*,'ALL INITIALIZATION'
 
 !     Initialize various variables
@@ -660,6 +654,4 @@
          enddo
       enddo
-
-      print*,'end ALL INITIALIZATION'
 
 !-----------------------------------------------------------------------
@@ -828,5 +820,4 @@
 !-------------------------
 
-      print*,'end RADIATIVE TRANSFER'
       endif ! of if (callrad)
 
@@ -996,5 +987,4 @@
          !-------------------------
          
-      print*,'end CONVADJ'
       endif ! of if(calladj)
 
@@ -1008,5 +998,4 @@
             call abort
          endif
-     print*, 'we are in co2cond!!!!!'
          call condense_cloud(ngrid,nlayer,nq,ptimestep,   &
               capcal,pplay,pplev,tsurf,pt,                  &
Index: trunk/LMDZ.GENERIC/libf/phystd/suaer_corrk.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/suaer_corrk.F90	(revision 803)
+++ trunk/LMDZ.GENERIC/libf/phystd/suaer_corrk.F90	(revision 804)
@@ -101,9 +101,13 @@
 !     Please also choose the reference wavelengths of each aerosol
 
+      if (noaero) then
+        print*, 'naerkind= 0'
+      endif
       do iaer=1,naerkind
-       if (iaer.eq.iaero_co2)then
+       if (iaer.eq.iaero_co2) then
         forgetit=.true.
-        print*, 'naerkind= co2', iaer
-
+          if (.not.noaero) then
+              print*, 'naerkind= co2', iaer
+          end if
 !     visible
         if(forgetit)then